#include <stdio.h> /* RTK 2008.1.5 */
#include <stdbool.h>

#define n 10000

bool AliObstajaZaporedjeKlicev(int a, int b)
{
	bool obvescen[n]; int u, v;
	for (u = 0; u < n; u++) obvescen[u] = false;
	obvescen[a] = true;
	while (scanf("%d %d", &u, &v) == 2)
	{
		if (obvescen[u]) obvescen[v] = true;
		if (obvescen[v]) obvescen[u] = true;
		if (obvescen[b]) break;
	}
	return obvescen[b];
}

void NajkrajseZaporedjeKlicev(int a, int b)
{
	int stKlicev[n], predhodnik[n], zaporedje[n], u, v;
	for (u = 0; u < n; u++) stKlicev[u] = n;
	stKlicev[a] = 0; predhodnik[a] = a;
	while (scanf("%d %d", &u, &v) == 2)
	{
		if (stKlicev[v] > stKlicev[u] + 1)
			stKlicev[v] = stKlicev[u] + 1, predhodnik[v] = u;
		if (stKlicev[u] > stKlicev[v] + 1)
			stKlicev[u] = stKlicev[v] + 1, predhodnik[u] = v;
	}
	if (stKlicev[b] == n) printf("%d ni dobil informacije od %d.\n", b, a);
	else {
		u = b;
		do { zaporedje[stKlicev[u]] = u; u = predhodnik[u]; }
		while (u != a);
		zaporedje[0] = a;
		for (u = 1; u <= stKlicev[b]; u++)
			printf("- oseba %d pove osebi %d\n", zaporedje[u - 1], zaporedje[u]);
	}
}

void Pomoc()
{
	printf("Sintaksa: rtk08s1n5 {a|b} xxxx yyyy");
	printf("xxxx, yyyy = dve telefonski tevilki");
	printf("a ali b = oznaka podnaloge");
}

#include <stdlib.h>

int main(int argc, char** argv)
{
	int a, b;
	if (argc != 4) { Pomoc(); return 1; }
	a = atoi(argv[2]); b = atoi(argv[3]);
	if (argv[1][0] == 'a') printf("AliObstajaZaporedjeKlicev(%d, %d) = %s\n",
		a, b, AliObstajaZaporedjeKlicev(a, b) ? "da" : "ne");
	else NajkrajseZaporedjeKlicev(a, b);
	return 0;
}
