/* RTK 2008.2.3 */
typedef struct { int zapSt, t1, t2, t3, t4; } SporociloT;

extern void PosljiSporocilo(SporociloT sporocilo);
extern void NastaviUro(int t);
extern int VrniUro();
extern void TuVmesNasLahkoKajPrekine();

void SinhronizirajUro()
{
	SporociloT sporocilo;
	sporocilo.zapSt = 1;
	sporocilo.t1 = VrniUro();
	sporocilo.t2 = -1;
	sporocilo.t3 = -1;
	sporocilo.t4 = -1;
	PosljiSporocilo(sporocilo);
}

void SprejemNaStrezniku(SporociloT sporocilo)
{
	if (sporocilo.zapSt != 2) return; /* napaka */
	sporocilo.zapSt = 3;
	sporocilo.t4 = VrniUro();
	TuVmesNasLahkoKajPrekine();
	PosljiSporocilo(sporocilo);
}

void SprejemNaOdjemalcu(SporociloT sporocilo)
{
	int r;
	if (sporocilo.zapSt == 1)
	{
		sporocilo.zapSt = 2;
		sporocilo.t2 = VrniUro();
		TuVmesNasLahkoKajPrekine();
		sporocilo.t3 = VrniUro();
		PosljiSporocilo(sporocilo);
	}
	else if (sporocilo.zapSt == 3)
	{
		TuVmesNasLahkoKajPrekine();
		r = (sporocilo.t2 - sporocilo.t4 - sporocilo.t1 + sporocilo.t3) / 2;
		printf("Popravek: r = %d\n", r);
		TuVmesNasLahkoKajPrekine();
		NastaviUro(VrniUro() - r);
	}
	/* e je sporocilo.zapSt kaj drugega kot 1 ali 3,
	   je nekje prilo do napake. */
}

/*----------------------------------------------------------------------------*
* Testna infrastruktura                                                       *
*----------------------------------------------------------------------------*/

#include <stdio.h>

typedef struct VrstaT_
{
	int casSprejema;
	SporociloT s;
	struct VrstaT_ *nasl;
} VrstaT;

typedef struct
{
	int cas, zamik; /* ura = cas + zamik */
	VrstaT *glava, *rep;
} RacunalnikT;

RacunalnikT rac[2];
int kdo; /* 0 = streznik, 1 = odjemalec */
int d; /* cas potovanja sporocila */

void PosljiSporocilo(SporociloT sporocilo)
{
	int p; VrstaT *v;
	printf("%d polje ob asu %d sporoilo (%d; %d, %d, %d, %d)\n",
		kdo, rac[kdo].cas, sporocilo.zapSt, sporocilo.t1,
		sporocilo.t2, sporocilo.t3, sporocilo.t4);
	p = 1 - kdo; /* prejemnik */
	v = (VrstaT *) malloc(sizeof(VrstaT));
	v->nasl = 0; v->s = sporocilo;
	v->casSprejema = rac[kdo].cas + d;
	if (! rac[p].glava) rac[p].glava = v;
	else rac[p].rep->nasl = v;
	rac[p].rep = v;
}

void NastaviUro(int t)
{
	rac[kdo].zamik = t - rac[kdo].cas;
}

int VrniUro()
{
	return rac[kdo].cas + rac[kdo].zamik;
}

void TuVmesNasLahkoKajPrekine()
{
	rac[kdo].cas += rand() % 5;
}

int main()
{
	VrstaT *v;

	srand((int) time());
	rac[0].glava = 0; rac[1].glava = 0;
	rac[0].rep = 0; rac[1].rep = 0;
	rac[0].cas = 123; rac[1].cas = 123;
	rac[0].zamik = rand() % 20; rac[1].zamik = rand() % 20;
	d = rand() % 10 + 5;
	printf("as potovanja sporoila: %d\n", d);
	printf("Zamik glede na pravi as: %d %d\n", rac[0].zamik, rac[1].zamik);
	kdo = 0; SinhronizirajUro(); /* to se izvede na streniku */
	while (rac[0].glava || rac[1].glava)
	{
		if (! rac[0].glava) kdo = 1;
		else if (! rac[1].glava) kdo = 0;
		else kdo = (rac[0].glava->casSprejema < rac[1].glava->casSprejema) ? 0 : 1;
		v = rac[kdo].glava; rac[kdo].glava = v->nasl;
		if (rac[kdo].cas < v->casSprejema) rac[kdo].cas = v->casSprejema;
		printf("%d prejme ob asu %d sporoilo (%d; %d, %d, %d, %d) in ga zane obdelovati ob asu %d.\n",
			kdo, v->casSprejema, v->s.zapSt, v->s.t1, v->s.t2, v->s.t3, v->s.t4, rac[kdo].cas);
		if (kdo == 0) SprejemNaStrezniku(v->s);
		else SprejemNaOdjemalcu(v->s);
		free(v);
	}
	printf("Zamik glede na pravi as: %d %d\n", rac[0].zamik, rac[1].zamik);
}
