program PTP; { RTK 2008.2.3 }

type SporociloT = record
  ZapSt, t1, t2, t3, t4: integer;
end; {SporociloT}

  procedure PosljiSporocilo(Sporocilo: SporociloT); forward;
  procedure NastaviUro(t: integer); forward;
  function VrniUro: integer; forward;
  procedure TuVmesNasLahkoKajPrekine; forward;

procedure SinhronizirajUro;
var Sporocilo: SporociloT;
begin
  Sporocilo.ZapSt := 1;
  Sporocilo.t1 := VrniUro;
  Sporocilo.t2 := -1;
  Sporocilo.t3 := -1;
  Sporocilo.t4 := -1;
  PosljiSporocilo(Sporocilo);
end; {SinhronizirajUro}

procedure SprejemNaStrezniku(Sporocilo: SporociloT);
begin
  if Sporocilo.ZapSt <> 2 then exit; { napaka }
  Sporocilo.ZapSt := 3; 
  Sporocilo.t4 := VrniUro;
  TuVmesNasLahkoKajPrekine;
  PosljiSporocilo(Sporocilo);
end; {SprejemNaStrezniku}

procedure SprejemNaOdjemalcu(Sporocilo: SporociloT);
var r: integer;
begin
  if Sporocilo.ZapSt = 1 then begin
    Sporocilo.ZapSt := 2; 
    Sporocilo.t2 := VrniUro;
    TuVmesNasLahkoKajPrekine;
    Sporocilo.t3 := VrniUro;
    PosljiSporocilo(Sporocilo);
  end else if Sporocilo.ZapSt = 3 then with Sporocilo do begin
    TuVmesNasLahkoKajPrekine;
    r := (t2 - t4 - t1 + t3) div 2;
    WriteLn('Popravek: r = ', r);
    NastaviUro(VrniUro - r);
  end;
  { e je Sporocilo.ZapSt kaj drugega kot 1 ali 3,
    je nekje prilo do napake. }
end; {SprejemNaOdjemalcu}

{-----------------------------------------------------------------------------}
{ Testna infrastruktura                                                       }
{-----------------------------------------------------------------------------}

type
  VrstaP = ^VrstaT;
  VrstaT = record
    CasSprejema: integer;
    S: SporociloT;
    Nasl: VrstaP;
  end; {VrstaT}
  
  RacunalnikT = record
    Cas, Zamik: integer; { Ura = Cas + Zamik }
    Glava, Rep: VrstaP;
  end; {RacunalnikT}

var
  Rac: array [1..2] of RacunalnikT;
  Kdo: integer; { 1 = streznik, 2 = odjemalec } 
  D: integer; { as potovanja sporoila }

procedure PosljiSporocilo(Sporocilo: SporociloT); 
var V: VrstaP; P: integer;
begin
  with Sporocilo do WriteLn(Kdo, ' poslje ob casu ', Rac[Kdo].Cas, ' sporocilo (', 
    ZapSt, '; ', t1, ', ', t2, ', ', t3, ', ', t4, ').');
  P := 3 - Kdo; { prejemnik }
  New(V); V^.Nasl := nil; V^.S := Sporocilo;
  with Rac[P] do begin
    V^.CasSprejema := Rac[Kdo].Cas + D;
    if Glava = nil then Glava := V else Rep^.Nasl := V;
    Rep := V;
  end; {with}
end; {PosljiSporocilo}

procedure NastaviUro(t: integer); 
begin
  Rac[Kdo].Zamik := t - Rac[Kdo].Cas;
end; {NastaviUro}

function VrniUro: integer; 
begin
  VrniUro := Rac[Kdo].Cas + Rac[Kdo].Zamik;
end; {VrniUro}

procedure TuVmesNasLahkoKajPrekine;
begin
  with Rac[Kdo] do Cas := Cas + Random(5);
end; {TuVmesNasLahkoKajPrekine}

var V: VrstaP;
begin {PTP}
  Randomize;
  Rac[1].Glava := nil; Rac[2].Glava := nil;
  Rac[1].Rep := nil; Rac[2].Rep := nil;
  Rac[1].Cas := 123; Rac[2].Cas := 123;
  Rac[1].Zamik := Random(20); Rac[2].Zamik := Random(20);
  D := Random(10) + 5;
  WriteLn('Cas potovanja sporocila: ', D);
  WriteLn('Zamik glede na pravi cas: ', Rac[1].Zamik, ' ', Rac[2].Zamik);
  Kdo := 1; SinhronizirajUro; { to se izvede na strezniku } 
  while (Rac[1].Glava <> nil) or (Rac[2].Glava <> nil) do begin
    if Rac[1].Glava = nil then Kdo := 2
    else if Rac[2].Glava = nil then Kdo := 1
    else if Rac[1].Glava^.CasSprejema < Rac[2].Glava^.CasSprejema then Kdo := 1
    else Kdo := 2;
    with Rac[Kdo] do begin
      V := Glava; Glava := V^.Nasl;
      if Cas <= V^.CasSprejema then Cas := V^.CasSprejema;
      WriteLn(Kdo, ' prejme ob casu ', V^.CasSprejema, ' sporocilo (', 
        V^.S.ZapSt, '; ', V^.S.t1, ', ', V^.S.t2, ', ', V^.S.t3, ', ', V^.S.t4,
        ') in ga zacne obdelovati ob casu ', Cas, '.');
      if Kdo = 1 then SprejemNaStrezniku(V^.S)
      else SprejemNaOdjemalcu(V^.S);
      Dispose(V);
    end; {with}
  end; {while}
  WriteLn('Zamik glede na pravi cas: ', Rac[1].Zamik, ' ', Rac[2].Zamik);
end. {PTP}

