#include <stdio.h> /* RTK 2008.3.4 */
#include <stdlib.h>
#include <stdbool.h>

#define MaxK 10000
#define MaxDolzT 1000000
#define MaxP 100

char p[MaxP + 1], u[MaxDolzT], t[MaxDolzT + 1];
/* Niz t_i je shranjen v t[tp[i]..tp[i] + td[i] - 1].
   Podobno je del niza s, namre s[uz[i]..uz[i] + ud[i] - 1],
   shranjen v tabeli u na mestih u[up[i]..up[i] + ud[i] - 1].
   Takih kosov s-ja je r. */
int n, k, r, pd; /* pd = dolina niza p */
int z[MaxK], td[MaxK], tp[MaxK], uz[MaxK], ud[MaxK], up[MaxK], tu[MaxK];
int zu[MaxK], zi[MaxK]; /* zu[j] = z[zi[j]] in tabela zu je urejena naraajoe */
char c;

bool SePojavlja(int kos, int j)
{
	int i; char sc;
	if (j + pd >= n) return false;
	i = 0;
	while (i < pd)
	{
		if (kos >= r) sc = c;
		else if (j >= uz[kos] + ud[kos]) { kos++; continue; }
		else if (j < uz[kos]) sc = c;
		else sc = u[up[kos] + j - uz[kos]];
		if (p[i] != sc) return false;
		i++; j++;
	}
	return true;
}

int main(int argc, char** argv)
{
	int i, j, pc, dolzT, dolzU, stPojavitev, cPred;
	char cc;

	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "nizi.in", "rt");
	fscanf(f, "%d %d\n", &n, &k);
	fscanf(f, "%c\n", &c);
	dolzT = 0;
	for (i = 0; i < k; i++)
	{
		fscanf(f, "%d %s\n", &z[i], &t[dolzT]);
		tp[i] = dolzT; z[i]--;
		while (t[dolzT]) dolzT++;
		td[i] = dolzT - tp[i];
	}
	fscanf(f, "%s\n", p); pd = strlen(p);
	fclose(f);

	/* Koliko c-jev je na zaetku p-ja? */
	pc = 0; while (pc < pd && p[pc] == c) pc++;
	/* Upotevajmo, da se t-ji lahko prekrivajo.  Uredimo jih po zaetkih. */
	for (i = 0; i < k; i++)
	{
		for (j = i - 1; j >= 0 && zu[j] > z[i]; j--)
			zi[j + 1] = zi[j], zu[j + 1] = zu[j];
		zi[j + 1] = i; zu[j + 1] = z[i];
	}
	/* Tam, kjer se ve t-jev prekriva ali dotika, bo nastal en sam dalji kos. */
	r = 0; j = 0; dolzU = 0;
	for (i = 0; i < k; i++)
	{
		/* Trenutni kos se kona pri j - 1; trenutni t se zane pri zu[i]. */
		if (zu[i] < j) { /* Podaljajmo trenutni kos, e je treba. */
			if (zu[i] + td[zi[i]] > j) j = zu[i] + td[zi[i]];
			ud[r - 1] = j - uz[r - 1]; }
		else { /* Zanimo nov kos. */
			if (r > 0) dolzU += ud[r - 1];
			up[r] = dolzU; uz[r] = zu[i];
			ud[r] = td[zi[i]]; j = uz[r] + ud[r]; r++; }
		/* Kam v tabelo u bomo morali skopirati trenutni t? */
		tu[zi[i]] = up[r - 1] + (zu[i] - uz[r - 1]);
	}
	dolzU += ud[r];
	/* Skopirajmo zdaj t-je v tabelo u. */
	for (i = 0; i < k; i++) for (j = 0; j < td[i]; j++)
		u[tu[i] + j] = t[tp[i] + j];
	/* Poiimo zdaj pojavitve niza v p v s. */
	stPojavitev = 0;
	for (i = 0; i < r; i++)
	{
		/* i-ti kos niza s obsega znake s[uz[i]..uz[i] + ud[i] - 1],
		   dejansko pa so shranjeni v u[up[i]..up[i] + ud[i] - 1].
		   Med prejnjim in tem kosom je cPred znakov c. */
		j = (i == 0) ? 0 : uz[i - 1] + ud[i - 1];
		cPred = uz[i] - j;
		/* Pretejmo pojavitve p-ja med prejnjim in trenutnim kosom. */
		if (pc == pd && cPred >= pd) stPojavitev += cPred - pd + 1;
		/* Pretejmo pojavitve p-ja, ki se zanejo v trenutnem kosu
		  ali pa v vmesnem obmoju med prejnjim in trenutnim ter segajo e v trenutnega. */
		if (j < uz[i] - pd + 1) j = uz[i] - pd + 1;
		while (j < uz[i] + ud[i])
		{
			if (j + pd - 1 > n) break;
			if (SePojavlja(i, j)) stPojavitev++;
			j++;
		}
	}
	/* Pretejmo pojavitve p-ja za zadnjim kosom. */
	if (pc == pd) {
		cPred = n - (uz[r - 1] + ud[r - 1]);
		if (cPred >= pd) stPojavitev += cPred - pd + 1; }

	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "nizi.out", "wt");
	fprintf(f, "%d\n", stPojavitev); fclose(f); return 0;
}
